# UnoCSS Starter

Starterkit theme w/ UnoCSS and Vite preconfigured.

Additional information on generating themes can be found in the [Starterkit documentation](https://www.drupal.org/docs/core-modules-and-themes/core-themes/starterkit-theme).

# Theming

Start by installing the theme with composer.

TODO: Get generate starterkit working.

Copy theme to custom and rename files as a workaround to begin theming.

Customize uno.config.js. See https://unocss.dev/config/ and other documentation pages.

Configure vite dev server to work with your local development environment (TODO: Documentation).

Start theming with tailwind utilities in templates, and @apply statements in css.
See https://unocss.dev/integrations/postcss.

Start dev mode with npm run dev, experiment in index.html and style.css.

TODO: Better integration between index.html and drupal theme (templates, components, libraries, etc).
See https://github.com/larowlan/vite-plugin-twig-drupal

TODO: Organize libraries, provide initial files.

## Generate subtheme
```php core/scripts/drupal generate-theme --path=themes/custom --starterkit=unocss_starter --name="New Theme" --description="UnoCSS starter theme." new_theme```

# Build process

How this theme is built.

1. Create a new starterkit theme.
  - php core/scripts/drupal generate-theme unocss_starter
2. Create vite project and install unocss.
  - npm create vite .
  - npm i -D unocss glob
3. Configure vite.
  - UnoCSS plugin.
  - Empty output dir, enable manifest.json.
  - Rollup input/output (see vite.config.js).
  - Enable vite in all libraries/components (see unocss_starter.info.yml).
  - [npm run build should now compile css]
4. Configure unocss.
  - presetUno.
  - Parse template classes.
  - Create unocss.js with import 'virtual:uno.css'.
  - Create unocss library w/ unocss.js, add as dependency to base.
  - [uno classes in templates now included in build]
5. Configure postcss.
   - See postcss.config.js.
   - [@apply in css should be transformed with uno]
6. Clean up vite files
  - Remove couter.js, javascript.svg.
  - Remove #app from index.html.
  - Clear out style.css.
