import UnoCSS from "unocss/vite";
import { defineConfig } from "vite";
import { globSync } from "glob";

export default defineConfig({
  plugins: [
    UnoCSS()
  ],
  build: {
    emptyOutDir: true,
    manifest: true,
    rollupOptions: {
      input: [
        'unocss.js',
        ...globSync('css/**/*.css'),
      ],
      output: {
        entryFileNames: `[name].js`,
        assetFileNames: `[name].[ext]`,
      },
    }
  }
})
